<template>
  <div v-if="serie" class="product product--slider">
    <div class="product_image">
      <a :href="url" @click="serieClick(url, $event)">
        <img
          :src="image"
          :alt="serie.slug"
          :class="{ adult: serie.gender && serie.gender.includes('Adult') }"
          width="170"
          height="260"
        />
        <div
          v-if="serie.gender && serie.gender.includes('Adult')"
          class="adult_disclaim"
        >
          18+
        </div>
      </a>
      <span
        v-if="serie.banner"
        :class="'product_label text--md product_banner-' + serie.banner"
        >{{ $t('catalog.banner.' + serie.banner) }}</span
      >
    </div>
    <a :href="url" @click="serieClick(url, $event)">
      <h4 class="product_title text text--sm text--primary text--bold">
        {{ serieName }}
      </h4>
    </a>
    <p class="product_numbers text text--sm text--primary text--medium">
      {{ amount }} {{ $tc('serie.volume', amount) }}
    </p>

    <StarRank
      v-if="serie.rate"
      :avgstar="serie.rate"
      :countnote="serie.rateAmount || serie.rate_amount"
    />

    <a :href="genreUrl">
      <p class="product_category text text--sm capitalized text--medium">
        {{ genre }}
      </p>
    </a>
    <p v-if="!hidePrice" class="price text text--sm text--primary text--medium">
      <span class="price_label">{{ $t('serie.fromprice') }}</span>
      <span v-if="serie.oldPrice || serie.lowest_oldprice">
        <del>
          <PriceFormat :price="serie.oldPrice || serie.lowest_oldprice" />
        </del>
      </span>
      <span class="product_lower_price">
        <span v-if="!serie.minPrice">N/A</span>
        <span v-else-if="serie.minPrice === '0.00'">{{
          $t('serie.free')
        }}</span>
        <PriceFormat v-else :price="serie.minPrice || serie.lowest_price" />
      </span>
    </p>
  </div>
</template>

<script>
import StarRank from '~/components/ui/StarRank'
import PriceFormat from '~/components/ui/PriceFormat'

export default {
  components: { StarRank, PriceFormat },
  props: {
    serie: {
      type: Object,
      required: true
    },
    subscribed: {
      type: Boolean,
      required: false,
      default: false
    },
    noPrice: {
      type: Boolean,
      required: false,
      default: false
    },
    pushImpressionClick: {
      type: Boolean,
      required: false,
      default: false
    },
    parentListName: {
      type: String,
      required: false,
      default: ''
    },
    positionInList: {
      type: Number,
      required: false,
      default: 0
    }
  },
  computed: {
    image() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/serie/${this.serie.id}-170or260.jpg?v=${this.serie.version}`
    },
    genreUrl() {
      return `/${this.$i18n.locale}${this.subscribed ? '/abo' : ''}/${
        this.serie.shelf || this.serie.shelf_slug
      }/${this.genre || this.serie.genre_slug}`
    },
    url() {
      if (this.serie.url) return this.serie.url

      return `/${this.$i18n.locale}${this.subscribed ? '/abo' : ''}/${
        this.serie.shelf
      }/${this.genre}/${this.serie.slug}-${this.serie.id}`
    },
    serieName() {
      let name = this.serie.title || this.serie.name

      if (name && name.length > 42) {
        name = name.slice(0, 42)
        name =
          name.substr(0, Math.min(name.length, name.lastIndexOf(' '))) + '...'
      }

      return name
    },
    amount() {
      if (this.serie.amount) return this.serie.amount

      return this.serie.albums_count
    },
    genre() {
      return this.serie.genre || this.serie.gender
    },
    hidePrice() {
      return this.noPrice || this.subscribed || !this.$store.state.auth.loggedIn
    }
  },
  methods: {
    // eslint-disable-next-line no-unused-vars
    serieClick(url, event) {
      if (this.pushImpressionClick) {
        event.preventDefault()

        const product = this.$utils.gtmAdvEcommerceCreateImpressionClickProduct(
          this.serie.title,
          this.serie.id,
          this.serie.minPrice ?? '',
          this.serie.shelf,
          'Series',
          this.positionInList
        )
        const e = this.$utils.gtmAdvEcommerceCreateProductClickEvent(
          product,
          this.parentListName
        )
        this.$utils.gtmEvent(e, url)
      }
    }
  }
}
</script>

<style scoped lang="scss">
.adult {
  -webkit-filter: grayscale;
  -webkit-filter: brightness(30%);
}

.adult_disclaim {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 80px;
  height: 80px;
  line-height: 70px;
  text-align: center;
  vertical-align: middle;
  font-size: 36px;
  font-weight: bold;
  color: #fff;
  border-radius: 50%;
  border: 5px solid #f3f3f3;
}

.price_label {
  opacity: 0.5;
}

.product--slider {
  pointer-events: auto !important;
  display: block !important;
}

.capitalized {
  text-transform: capitalize;
}
</style>
